#pragma once

#include "Figments/Figment.h"
#include <vector>

class Sequencer: public Task {
public:

    class Scene {
      public:
        const char* name;
        std::vector<const char*> patterns;
    };

    Sequencer(std::vector<Scene> &&scenes);

    void loop() override;
    void handleEvent(const InputEvent& evt) override;

    const char* currentSceneName();
    const std::vector<Scene> scenes() const;

private:
    int m_idx = 0;
    std::vector<Scene> m_scenes;
};
